package tse.practico1;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import jakarta.ejb.Local;
import jakarta.ejb.Remote;
import jakarta.ejb.Singleton;
import jakarta.persistence.EntityManager;
import jakarta.persistence.PersistenceContext;
import tse.practico1.Usuario;

/**
 * Session Bean implementation class MySingleton
 */
@Remote(MySingletonRemote.class)
@Local(MySingletonLocal.class)
@Singleton
public class MySingleton implements MySingletonRemote, MySingletonLocal {
	private List<Usuario> usuarios = new ArrayList<Usuario>();
	
	@PersistenceContext(name = "TSE2024")
	private EntityManager em;

    /**
     * Default constructor. 
     */
    public MySingleton() {
        // TODO Auto-generated constructor stub
    }
    
    public Usuario altaUsuario(String nombre, String añoNacimiento, String fechaRegistro) {
    	try {
	    	SimpleDateFormat formato = new SimpleDateFormat("yyyy-MM-dd");
	    	Integer añoNacimientoInteger = Integer.parseInt(añoNacimiento);
	    	Date fechaRegistroDate = formato.parse(fechaRegistro);
	    	Usuario nuevoUsuario = new Usuario(nombre, añoNacimientoInteger, fechaRegistroDate);
	    	usuarios.add(nuevoUsuario);
	    	em.persist(nuevoUsuario);
	    	return nuevoUsuario;
    	} catch (Exception e) {
	        //e.printStackTrace();
    		System.err.println("Ocurrió un error al parsear los datos ingresados: " + e.getMessage());
	        return null;
	    }
    }
    
    public Usuario buscarUsuario(String nombreBuscado) {
    	for(Integer i = 0; i<usuarios.size(); i++) {
    		if (usuarios.get(i).getNombre().equals(nombreBuscado)) {
    			return usuarios.get(i);
    		};
    	}
    	return null;
    }
    
    public List<Usuario> listaUsuarios(){
    	return new ArrayList<>(usuarios);
    }

}
