package tse.practico1;

import java.time.LocalDate;
import java.util.Date;
import java.util.List;

import jakarta.ejb.EJB;
import jakarta.ejb.Local;
import jakarta.ejb.Remote;
import jakarta.ejb.Stateless;
import tse.practico1.Usuario;

/**
 * Session Bean implementation class Usuario
 */
@Remote(UsuarioRemote.class)
@Local(UsuarioLocal.class)
@Stateless
public class UsuarioBean implements UsuarioLocal, UsuarioRemote {
	
	@EJB
	private MySingletonRemote singleton;
	
    /**
     * Default constructor. 
     */
    public UsuarioBean() {
        // TODO Auto-generated constructor stub
    }
    
    public List<Usuario> listaUsuarios(){
    	return singleton.listaUsuarios();
    }
    
    public Usuario altaUsuario(String nombre, String añoNacimiento, String fechaRegistro){
    	return singleton.altaUsuario(nombre, añoNacimiento, fechaRegistro);
    }
    
    public Usuario buscarUsuario(String nombre){
    	return singleton.buscarUsuario(nombre);
    }
}
