

import jakarta.annotation.Resource;
import jakarta.ejb.EJB;
import jakarta.inject.Inject;
import jakarta.servlet.ServletException;
import jakarta.servlet.annotation.WebServlet;
import jakarta.servlet.http.HttpServlet;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import jakarta.jms.Queue;
import jakarta.jms.JMSContext;
import jakarta.jms.JMSDestinationDefinitions;
import jakarta.jms.JMSProducer;
import jakarta.jms.JMSDestinationDefinition;
import jakarta.jms.Destination;


import tse.practico1.Usuario;

@JMSDestinationDefinitions(
		value = {
				@JMSDestinationDefinition(
					name = "java:/queue/AltaUsuarioMDBQueue",
					interfaceName = "jakarta.jms.Queue",
					destinationName = "AltaUsuarioMDBQueue"
				),
		}
		)

/**
 * Servlet implementation class Usuario
 */
@WebServlet("/AltaUsuarioMDBServletClient")
public class AltaUsuarioMDBServletClient extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	private static final int MSG_COUNT = 5;
	
	@EJB
	private tse.practico1.UsuarioRemote usuarioRemote;
	
	@Inject
	private JMSContext context;
	
	@Resource(lookup = "java:/queue/AltaUsuarioMDBQueue")
	private Queue queue;
	
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public AltaUsuarioMDBServletClient() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		resp.setContentType("text/html");
		Integer añoNacimiento = 2000;
		try {
			final Destination destination = queue;
			for (int i=0; i < MSG_COUNT; i++) {
				String text = "nombre" + i + "|" + (añoNacimiento + i) + "|" + "2020-01-07";
				JMSProducer producer = context.createProducer();
				producer.send(destination, text);
			}
			req.getRequestDispatcher("index.jsp").forward(req, resp);
		} finally {
		}
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}

}
