package beans;

import jakarta.annotation.PostConstruct;
import jakarta.ejb.EJB;
import jakarta.enterprise.context.SessionScoped;
import jakarta.inject.Named;
import java.io.Serializable;
import java.time.LocalDate;
import java.util.List;

import tse.practico1.Usuario;

@Named("inicioBean")
@SessionScoped
public class InicioBean implements Serializable {

	
	private static final long serialVersionUID = 1L;
	
	@EJB
	tse.practico1.UsuarioRemote usuarioRemote;

	private String nombreBuscado;
	private Usuario usuarioBuscado;
	
	private String nombre;
	private String anioNacimiento;
	private String fechaRegistro;
	
	private List<Usuario> usuarios;

	
	public InicioBean() {
	}
	
	@PostConstruct
	public void init() {
		this.usuarios = usuarioRemote.listaUsuarios();
	}
	
	public String getNombreBuscado() { return this.nombreBuscado; }
	public void setNombreBuscado(String nombreBuscado) { this.nombreBuscado = nombreBuscado; }
	public Usuario getUsuarioBuscado() { return this.usuarioBuscado; }
	public void setUsuarioBuscado(Usuario usuarioBuscado) { this.usuarioBuscado = usuarioBuscado; }
	
	public String getNombre() { return this.nombre; }
	public void setNombre(String nombre) { this.nombre = nombre; }
	public String getAnioNacimiento() { return this.anioNacimiento; }
	public void setAnioNacimiento(String anioNacimiento) { this.anioNacimiento = anioNacimiento; }
	public String getFechaRegistro() { return this.fechaRegistro; }
	public void setFechaRegistro(String fechaRegistro) { this.fechaRegistro = fechaRegistro; }
	
	public List<Usuario> getUsuarios() { return this.usuarios; }
	public void setUsuarios(List<Usuario> usuarios) { this.usuarios = usuarios; }

	public String buscarUsuario() {
		System.out.println(nombreBuscado);
		setUsuarioBuscado(usuarioRemote.buscarUsuario(nombreBuscado));
		return "buscarUsuario";
	}
	
	public String listarUsuarios() {
		return "listaUsuarios";
	}
	
	public String crearUsuario() {
		usuarioRemote.altaUsuario(nombre, anioNacimiento, fechaRegistro);
		this.usuarios = usuarioRemote.listaUsuarios();
		return "crearUsuario";
	}
	
	public String volverAlInicio() {
		return "volverAlInicio";
	}
}
